'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.JavaScriptFile = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _util = require('util');

var _escodegen = require('escodegen');

var _escodegen2 = _interopRequireDefault(_escodegen);

var _esprima = require('esprima');

var esprima = _interopRequireWildcard(_esprima);

var _esquery = require('esquery');

var _esquery2 = _interopRequireDefault(_esquery);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _tractorFileStructure = require('tractor-file-structure');

var _javascriptFileRefactorer = require('./javascript-file-refactorer');

var _tractorErrorHandler = require('tractor-error-handler');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Constants:
var LEADING_SLASH_REGEX = /^\//;
var LITERAL = 'Literal';
var REGEXP_CONTENT_REGEX = /^\/.*\/[gimuy]*?$/;
var REGEXP_FLAGS_REGEX = /([gimuy]*)$/;
var REQUEST_ERROR = 400;
var REQUIRE_QUERY = 'CallExpression[callee.name="require"] Literal';
var TRAILING_SLASH_REGEX = /(\/)[gimuy]*?$/;

// Utilities:


// Dependencies:


// Errors:

var JavaScriptFile = exports.JavaScriptFile = function (_File) {
    _inherits(JavaScriptFile, _File);

    function JavaScriptFile() {
        _classCallCheck(this, JavaScriptFile);

        return _possibleConstructorReturn(this, (JavaScriptFile.__proto__ || Object.getPrototypeOf(JavaScriptFile)).apply(this, arguments));
    }

    _createClass(JavaScriptFile, [{
        key: 'read',
        value: function read() {
            var _this2 = this;

            // Hack to fix coverage bug: https://github.com/gotwarlost/istanbul/issues/690
            /* istanbul ignore next */
            var read = _get(JavaScriptFile.prototype.__proto__ || Object.getPrototypeOf(JavaScriptFile.prototype), 'read', this).call(this);

            return read.then(function (content) {
                return setAST.call(_this2, content);
            }).then(function () {
                return getReferences.call(_this2);
            }).then(function () {
                return _this2.content;
            }).catch(function () {
                throw new _tractorErrorHandler.TractorError('Parsing "' + _this2.path + '" failed.', REQUEST_ERROR);
            });
        }
    }, {
        key: 'refactor',
        value: function refactor(type, data) {
            var _this3 = this;

            // Hack to fix coverage bug: https://github.com/gotwarlost/istanbul/issues/690
            /* istanbul ignore next */
            var refactor = _get(JavaScriptFile.prototype.__proto__ || Object.getPrototypeOf(JavaScriptFile.prototype), 'refactor', this).call(this, type, data);

            return refactor.then(function () {
                var change = _javascriptFileRefactorer.JavaScriptFileRefactorer[type];
                return change ? change(_this3, data) : null;
            }).then(function () {
                return _this3.save(_this3.ast);
            });
        }
    }, {
        key: 'save',
        value: function save(javascript) {
            var _this4 = this;

            if (!(0, _util.isString)(javascript) && !Buffer.isBuffer(javascript)) {
                var ast = javascript;
                ast.leadingComments = ast.comments;
                javascript = _escodegen2.default.generate(rebuildRegExps(ast), {
                    comment: true
                });
            }

            // Hack to fix coverage bug: https://github.com/gotwarlost/istanbul/issues/690
            /* istanbul ignore next */
            var save = _get(JavaScriptFile.prototype.__proto__ || Object.getPrototypeOf(JavaScriptFile.prototype), 'save', this).call(this, javascript);

            return save.then(function (content) {
                return setAST.call(_this4, content);
            }).then(function () {
                return getReferences.call(_this4);
            }).then(function () {
                return _this4.content;
            }).catch(function () {
                throw new _tractorErrorHandler.TractorError('Saving "' + _this4.path + '" failed.', REQUEST_ERROR);
            });
        }
    }, {
        key: 'serialise',
        value: function serialise() {
            // Hack to fix coverage bug: https://github.com/gotwarlost/istanbul/issues/690
            /* istanbul ignore next */
            var serialised = _get(JavaScriptFile.prototype.__proto__ || Object.getPrototypeOf(JavaScriptFile.prototype), 'serialise', this).call(this);

            serialised.ast = this.ast;
            return serialised;
        }
    }, {
        key: 'toJSON',
        value: function toJSON() {
            // Hack to fix coverage bug: https://github.com/gotwarlost/istanbul/issues/690
            /* istanbul ignore next */
            var json = _get(JavaScriptFile.prototype.__proto__ || Object.getPrototypeOf(JavaScriptFile.prototype), 'toJSON', this).call(this);

            var meta = void 0;
            try {
                var _ast$comments = _slicedToArray(this.ast.comments, 1),
                    metaComment = _ast$comments[0];

                meta = JSON.parse(metaComment.value);
            } catch (e) {
                meta = null;
            }
            json.meta = meta;
            return json;
        }
    }]);

    return JavaScriptFile;
}(_tractorFileStructure.File);

function rebuildRegExps(object) {
    Object.keys(object).forEach(function (key) {
        var value = object[key];
        if (value && isRegexLiteral(value)) {
            var regexContent = value.raw.replace(LEADING_SLASH_REGEX, '').replace(TRAILING_SLASH_REGEX, '');

            var _REGEXP_FLAGS_REGEX$e = REGEXP_FLAGS_REGEX.exec(value.raw),
                _REGEXP_FLAGS_REGEX$e2 = _slicedToArray(_REGEXP_FLAGS_REGEX$e, 1),
                regexFlags = _REGEXP_FLAGS_REGEX$e2[0];

            value.value = new RegExp(regexContent, regexFlags);
        } else if (Array.isArray(value) || (0, _util.isObject)(value)) {
            rebuildRegExps(value);
        }
    });
    return object;
}

function getReferences() {
    var _this5 = this;

    if (this.initialised) {
        this.fileStructure.referenceManager.clearReferences(this.path);
    }

    (0, _esquery2.default)(this.ast, REQUIRE_QUERY).forEach(function (requirePath) {
        var directoryPath = _path2.default.dirname(_this5.path);
        var referencePath = _path2.default.resolve(directoryPath, requirePath.value);
        var reference = _this5.fileStructure.referenceManager.getReference(referencePath);
        if (reference) {
            _this5.addReference(reference);
        }
    });

    this.initialised = true;
}

function isRegexLiteral(object) {
    var raw = object.raw,
        type = object.type;

    return type === LITERAL && raw && REGEXP_CONTENT_REGEX.test(raw);
}

function setAST(content) {
    this.ast = esprima.parseScript(content, {
        comment: true
    });
    this.data = this.ast;
    return content;
}